(* Wolfram Language Test file *)

(*	TODO: List of TODOs
	- DiracDelta: integration variable left over is merely a convention
	- DiracDelta: strict implication for 0 - indexed variable?
	- Product of Integrals: automatically rename integration variables?
*)

(* Integrate about 0 *)
Test[
	QAIntegrate[0, V, 3, x],
	0,
	TestID->"Integrate-20181213-S5W1J8"
]

(* Integrate about constant *)
Test[
	QAIntegrate[Pi, V, 3, x],
	Pi V,
	TestID->"Integrate-20181213-D4I4H9"
]

(* Put constant outside Integrate *)
Test[
	QAIntegrate[E Subscript[x, 1], V, 3, x],
	E QAIntegrate[Subscript[x, 1], V, 3, x],
	TestID->"Integrate-20181213-O9I5B4"
]

(* Combine product of Integrations *)
Test[
	QAIntegrate[Subscript[x, 1], V, 3, x] QAIntegrate[Subscript[y, 2], V, 3, y],
	QAIntegrate[Subscript[x, 1] Subscript[y, 2], V, 3, x, y],
	TestID->"Integrate-20181213-P3R4W5"
]

(* Apply DiracDelta in Integrate about 2 integration ranges *)
Test[
	QAIntegrate[
		Subscript[x, 1] Subscript[y, 2] * 
		DiracDelta[Subscript[x, 1] - Subscript[y, 1], Subscript[x, 2] - Subscript[y, 2], Subscript[x, 3] - Subscript[y, 3]], 
		V, 3, x, y],
	QAIntegrate[Subscript[x, 1] Subscript[x, 2], V, 3, x],
	TestID->"Integrate-20181213-N8K6H2"
]

(* Integrate about Exponential resolved to DiracDelta *)
Test[
	QAIntegrate[
		Power[E, I (Subscript[k, 1] (Subscript[x, 1] - Subscript[y, 1]) + Subscript[k, 2] (Subscript[x, 2] - Subscript[y, 2]))], 
		Infinity, 2, k],
	DiracDelta[Subscript[x, 1] - Subscript[y, 1], Subscript[x, 2] - Subscript[y, 2]] 4 Pi^2,
	TestID->"Integrate-20181216-P1R1T9"
]

(* Integrate about Exponential resolved to DiscreteDelta *)
Test[
	QAIntegrate[
		Power[E, -I (Subscript[x, 0] (Subscript[j, 0] + Subscript[k, 0]) - Subscript[x, 1] (Subscript[j, 1] + Subscript[k, 1]) - Subscript[x, 2] (Subscript[j, 2] + Subscript[k, 2]))], 
		A, 2, x],
	DiscreteDelta[Subscript[j, 1] + Subscript[k, 1], Subscript[j, 2] + Subscript[k, 2]] * 
		A Exp[-I (Subscript[x, 0] (Subscript[j, 0] + Subscript[k, 0]))],
	TestID->"Integrate-20181216-E7X5C9"
]

(* Integrate about Exponential resolved to DiscreteDelta with expanded subexpressions *)
Test[
	QAIntegrate[
		Power[E, -I ((Subscript[x, 0] Subscript[j, 0] + Subscript[x, 0] Subscript[k, 0]) - (Subscript[x, 1] Subscript[j, 1] + Subscript[x, 1] Subscript[k, 1]) - (Subscript[x, 2] Subscript[j, 2] + Subscript[x, 2] Subscript[k, 2]))], 
		A, 2, x],
	DiscreteDelta[Subscript[j, 1] + Subscript[k, 1], Subscript[j, 2] + Subscript[k, 2]] * 
		A Exp[-I (Subscript[x, 0] (Subscript[j, 0] + Subscript[k, 0]))],
	TestID->"Integrate-20181224-A6A7B1"
]
