(* Wolfram Language Test file *)

(* Test of Name Ordering Rule, op1 ** op2 are in reverse order *)
Test[
	(op1 = Operator[q, "H", { Subscript[k, 1], Subscript[k, 2] }, {}];
	op2 = Operator[p, "H", { Subscript[l, 1], Subscript[l, 2] }, {}];
	(op1 ** op2) /. { DefineNameOrderingRule[False, 2] }),
	op2 ** op1,
	TestID->"NameOrdering-20181226-X4S4F9"
]

(* Test of Name Ordering Rule, op1 ** op2 are in order *)
Test[
	(op1 = Operator[p, { Subscript[k, 1], Subscript[k, 2] }, {}];
	op2 = Operator[q, { Subscript[l, 1], Subscript[l, 2] }, {}];
	(op1 ** op2) /. { DefineNameOrderingRule[False, 2] }),
	op1 ** op2,
	TestID->"NameOrdering-20181226-D8L6F5"
]

(* Test of Name Ordering Rule, op1 ** op2 are in reverse order *)
(* Same as above but with Anti Commutator *)
Test[
	(op1 = Operator[q, "H", { Subscript[k, 1], Subscript[k, 2] }, {}];
	op2 = Operator[p, "H", { Subscript[l, 1], Subscript[l, 2] }, {}];
	(op1 ** op2) /. { DefineNameOrderingRule[True, 2] }),
	- op2 ** op1,
	TestID->"NameOrdering-20181226-C6Y4M7"
]

(* Test of Name Ordering Rule, op1 ** op2 are in order *)
(* Same as above but with Anti Commutator *)
Test[
	(op1 = Operator[p, { Subscript[k, 1], Subscript[k, 2] }, {}];
	op2 = Operator[q, { Subscript[l, 1], Subscript[l, 2] }, {}];
	(op1 ** op2) /. { DefineNameOrderingRule[True, 2] }),
	op1 ** op2,
	TestID->"NameOrdering-20181226-X2N0G3"
]

