(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15574,        500]
NotebookOptionsPosition[     10359,        348]
NotebookOutlinePosition[     13697,        429]
CellTagsIndexPosition[     13612,        424]
WindowTitle->OperatorQ - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "SymbolColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Mathematica",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:QuantumAlgebra/guide/QuantumAlgebra"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["QUANTUMALGEBRA PACKAGE PACLET SYMBOL", "PacletNameCell"], Cell[
    TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"BraQ\"\>":>Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/BraQ"], "\<\"ConstantQ\"\>":>
       Documentation`HelpLookup[
       "paclet:QuantumAlgebra/ref/ConstantQ"], "\<\"KetQ\"\>":>
       Documentation`HelpLookup["paclet:QuantumAlgebra/ref/KetQ"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"QuantumAlgebra/ref/OperatorQ\"\>":>
       None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["QuantumAlgebra/ref/OperatorQ"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/QuantumAlgebra/ref/\
OperatorQ.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "QuantumAlgebra/ref/OperatorQ", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell["OperatorQ", "ObjectName",
 CellID->1224892054],

Cell[CellGroupData[{

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OperatorQ", "[", 
       StyleBox["ex", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]checks if the expression ex is an ",
     Cell[BoxData[
      ButtonBox["Operator",
       BaseStyle->"Link",
       ButtonData->"paclet:QuantumAlgebra/ref/Operator"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->407161372],

Cell["\<\
Unlike the KetQ and the BraQ cases OperatorQ returns also True for composed \
Operators. The following cases are handled accordingly:\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
- simple Operator with head Operator\[LineSeparator]- non-commutative product \
of Operators\[LineSeparator]- analytical function of Operator like Exp, Log, \
Sin, Cos\[LineSeparator]- sum of Operators\[LineSeparator]- scalar product of \
constant with Operator\[LineSeparator]- non negative integer Powers of \
Operator\
\>", "Notes",
 CellID->204765248]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->5610702],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection",
 CellID->370250094],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Loads", " ", "the", " ", "application"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Needs", "[", "\"\<QuantumAlgebra`\>\"", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->724229819],

Cell[CellGroupData[{

Cell[BoxData["\<\"Application Quantum Algebra by Juergen Habelt\"\>"], "Print",
 CellID->17231160],

Cell[BoxData["\<\"This package is based on the work of Cesar Guerra \
G.,\"\>"], "Print",
 CellID->639371485],

Cell[BoxData["\<\"who developed the original package for Mathematica \
4.1/4.2\"\>"], "Print",
 CellID->134703327],

Cell[BoxData["\<\"For proper styling You should invoke SetNotebookStyles \
once.\"\>"], "Print",
 CellID->232651462]
}, Open  ]],

Cell[BoxData["\<\"ALIASES:\\nESC op ESC - Operator without index\\nESC hop \
ESC - Hermitian Operator without index\\nESC ket ESC - Ket without \
index\\nESC ketd ESC - Ket with subscript(s)\\nESC ketu ESC - Ket with \
superscript(s)\\nESC ketdu ESC - Ket with subscript(s) & superscript(s)\\nESC \
bra ESC - Ket without index\\nESC dbra ESC - Bra with subscript(s)\\nESC ubra \
ESC - Bra with superscript(s)\\nESC dubra ESC - Bra with subscript(s) & \
superscript(s)\\nESC (du)braket(du) ESC - Bra with (left and / or right) \
subscript(s) and / or superscript(s).\"\>"], "Output",
 ImageSize->{390, 220},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->523651377]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Simple", " ", "Hermitian", " ", "of", " ", 
   OverscriptBox["a", "^"]}], " ", "*)"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->58633189],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OperatorQ", "[", 
  SuperscriptBox[
   OverscriptBox["a", "^"], "\[Dagger]"], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->443778187],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->3713863]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"A", " ", "Commutator", " ", "of", " ", "2", " ", "Operators"}], 
   ",", " ", 
   RowBox[{"here", " ", "Location", " ", "and", " ", "Momentum"}]}], " ", 
  "*)"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->148257341],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OperatorQ", "[", 
  SubscriptBox[
   RowBox[{"[", 
    RowBox[{
     OverscriptBox["x", "^"], ",", 
     OverscriptBox["p", "^"]}], "]"}], "-"], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->279407318],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->20052424]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "The", " ", "Exponential", " ", "of", " ", "some", " ", "Angular", " ", 
   "Momentum", " ", "Operator"}], " ", "*)"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->802846633],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", 
    OverscriptBox["J", "^"], " ", 
    RowBox[{"\[Phi]", "/", "\[HBar]"}]}], "]"}], "//", "OperatorQ"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->5822667],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->322093929]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["BraQ",
    BaseStyle->"Link",
    ButtonData->"paclet:QuantumAlgebra/ref/BraQ"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["ConstantQ",
    BaseStyle->"Link",
    ButtonData->"paclet:QuantumAlgebra/ref/ConstantQ"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["KetQ",
    BaseStyle->"Link",
    ButtonData->"paclet:QuantumAlgebra/ref/KetQ"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OperatorQ - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2016, 5, 31, 18, 15, 2.2156648}", "context" -> 
    "QuantumAlgebra`", "keywords" -> {"OperatorQ Operator"}, "index" -> True, 
    "label" -> "QuantumAlgebra Package Paclet Symbol", "language" -> "en", 
    "paclet" -> "QuantumAlgebra Package", "status" -> "None", "summary" -> 
    "OperatorQ[ex] checks if the expression ex is an Operator.", 
    "synonyms" -> {}, "title" -> "OperatorQ", "type" -> "Symbol", "uri" -> 
    "QuantumAlgebra/ref/OperatorQ"}, "LinkTrails" -> "", 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 7, 2015)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell["Bra Ket Styles", "Section"], 
   Cell[" The cells below define certain styles needed for defining \
Bras&Kets.These styles serve to give the correct structural properties to \
Bras & Kets ", "Text"], 
   Cell[
    StyleData["BraKetArg"], SpanMinSize -> Automatic, StyleMenuListing -> 
    None, AdjustmentBoxOptions -> {BoxMargins -> {{0, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> True, Selectable -> True}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> "UnmatchedBracket"}], 
   Cell[
    StyleData["BraWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.2, -0.13}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["KetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, SpanMinSize -> 
    2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.1, 0.2}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["BraKetWrapper"], ScriptBaselineShifts -> {0.6, 0.9}, 
    SpanMinSize -> 2, StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0.25, 0.25}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}, 
    AutoStyleOptions -> {"UnmatchedBracketStyle" -> None}], 
   Cell[
    StyleData["RIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{-0.16, 0}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}], 
   Cell[
    StyleData["LIndex"], StyleMenuListing -> None, 
    AdjustmentBoxOptions -> {BoxMargins -> {{0, -0.1}, {0, 0}}}, 
    TagBoxOptions -> {Editable -> False}]}, Visible -> False, FrontEndVersion -> 
  "10.2 for Microsoft Windows (64-bit) (July 7, 2015)", StyleDefinitions -> 
  "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5216, 153, 459, 13, 30, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->5610702]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13471, 417}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 76, 1, 3, "SymbolColorBar"],
Cell[682, 24, 194, 5, 19, "LinkTrail"],
Cell[879, 31, 2520, 57, 48, "AnchorBarGrid",
 CellID->1],
Cell[3402, 90, 52, 1, 43, "ObjectName",
 CellID->1224892054],
Cell[CellGroupData[{
Cell[3479, 95, 533, 16, 83, "Usage"],
Cell[CellGroupData[{
Cell[4037, 115, 580, 17, 42, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->407161372],
Cell[4620, 134, 179, 4, 70, "Notes",
 CellID->1067943069],
Cell[4802, 140, 365, 7, 70, "Notes",
 CellID->204765248]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5216, 153, 459, 13, 30, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->5610702],
Cell[CellGroupData[{
Cell[5700, 170, 148, 5, 25, "ExampleSection",
 CellID->370250094],
Cell[CellGroupData[{
Cell[5873, 179, 252, 7, 47, "Input",
 CellID->724229819],
Cell[CellGroupData[{
Cell[6150, 190, 98, 1, 23, "Print",
 CellID->17231160],
Cell[6251, 193, 109, 2, 23, "Print",
 CellID->639371485],
Cell[6363, 197, 114, 2, 23, "Print",
 CellID->134703327],
Cell[6480, 201, 116, 2, 23, "Print",
 CellID->232651462]
}, Open  ]],
Cell[6611, 206, 714, 12, 241, "Output",
 CellID->523651377]
}, Open  ]],
Cell[7340, 221, 184, 5, 28, "Input",
 CellID->58633189],
Cell[CellGroupData[{
Cell[7549, 230, 161, 5, 70, "Input",
 CellID->443778187],
Cell[7713, 237, 159, 5, 36, "Output",
 CellID->3713863]
}, Open  ]],
Cell[7887, 245, 274, 8, 70, "Input",
 CellID->148257341],
Cell[CellGroupData[{
Cell[8186, 257, 228, 8, 70, "Input",
 CellID->279407318],
Cell[8417, 267, 160, 5, 36, "Output",
 CellID->20052424]
}, Open  ]],
Cell[8592, 275, 220, 6, 70, "Input",
 CellID->802846633],
Cell[CellGroupData[{
Cell[8837, 285, 256, 8, 70, "Input",
 CellID->5822667],
Cell[9096, 295, 161, 5, 36, "Output",
 CellID->322093929]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9318, 307, 417, 12, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[9738, 321, 579, 22, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[10332, 346, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)
